<!-- [formgroup]="loginForm" -> binding the form to the formgroup in .ts -->
<form [formGroup]="loginForm">
    <input id="trainer-name" name="trainer-name" formControlName="trainerName" type="text"
        placeholder="Enter your trainer name" required minlength="2" maxlength="20" />

    <div *ngIf=" trainerName.invalid && (trainerName.dirty || trainerName.touched)">
        <!-- Required-->
        <p *ngIf="trainerName.errors.required">
            Trainer name is required
        </p>
        <!-- Min Length-->
        <p *ngIf="trainerName.errors.minlength">
            Min 2 characters
        </p>
        <!-- Max Length-->
        <p *ngIf="trainerName.errors.maxlength">
            Max 20 characters
        </p>
        <!-- Pattern-->
        <p *ngIf="trainerName.errors.pattern">
            Allowed characters: a-Z and numbers
        </p>
    </div>
    <!-- Disables the button until the input is valid -->
    <button [disabled]="loginForm.invalid || loading" type="button" (click)="onStartClicked()">Login Trainer
    </button>

    <button [disabled]="loginForm.invalid || loading" type="button" (click)="onRegisterClick()">Register Trainer
    </button>

    <p *ngIf="error">{{ error }}</p>
</form>